#include <iostream>
#include <exception>

using namespace std;

struct ListElement
{
	ListElement()
		: data(0), pNext(NULL) {}

	ListElement(int i)
		: data(i), pNext(NULL) {}

	ListElement(int i, ListElement *pNext)
		: data(i), pNext(pNext) {}

	int data;
	ListElement *pNext;
};

class LinkedList
{
public:
	LinkedList() : root(NULL), count(0) {}
	LinkedList(const LinkedList&);
	~LinkedList();

	void addTail(int i);
	void addHead(int i);
	void clear();
	int  getCount() { return count; };

private:
	ListElement *root;
	int count;
};

int main()
{
	LinkedList list1, list2;

	cout << "пJYzƦrAåH@ӫDƦrNJ" << endl;
	cout << "пJĤ@ list  : ";
	cin >> list1;

	cout << "пJĤG list  : ";
	cin >> list2;

	cout << "list1 : " << list1 << endl;
	cout << "list2 : " << list2 << endl;

	cout << "===== operator [] ============" << endl;

	for (int i = 0; i < list1.getCount(); i++)
		cout << "list[" << i << "] = " << list1[i] << endl;

	cout << "===== operator + =============" << endl;

	cout << "list3 = list1 + list2" << endl;
	LinkedList list3 = list1 + list2;
	cout << "list3 = " << list3 << endl;

	cout << "===== operator = =============" << endl;

	cout << " list2 = list1 " << endl;
	list2 = list1;

	cout << "list1 : " << list1 << endl;
	cout << "list2 : " << list2 << endl;

	cout << "list1 P list2 O_ۦP : " << (list1 == list2) << endl;

	cout << "list1.addTail(10);" << endl;

	list1.addTail(10);

	cout << "list1 : " << list1 << endl;
	cout << "list2 : " << list2 << endl;

	cout << "list1 P list2 O_ۦP : " << (list1 == list2) << endl;

	cout << " list1 += list2" << endl;

	list1 += list2;

	cout << list1 << endl;

	cout << "===== operator - =============" << endl;
	cout << "-list1 : " << -list1 << endl;

	cout << "===== prefix operator -- =====" << endl;
	cout << "list1   : " << list1 << endl;
	cout << "--list1 : " << --list1 << endl;
	cout << "list1   : " << list1 << endl;

	cout << "===== postfix operator -- ====" << endl;
	cout << "list1   : " << list1 << endl;
	cout << "list1-- : " << list1-- << endl;
	cout << "list1   : " << list1 << endl;

	return 0;
}

LinkedList::LinkedList(const LinkedList &ll)
	: root(NULL), count(0)
{
	// copy constructor
}

LinkedList::~LinkedList()
{
	// destructor
}

void LinkedList::addTail(int i)
{
	if (root == NULL)
	{
		root = new ListElement(i);
	}
	else
	{
		ListElement *tmp = root;
		
		while (tmp->pNext != NULL)
		{
			tmp = tmp->pNext;
		}

		tmp->pNext = new ListElement(i, NULL);
	}
	++count;
}

void LinkedList::addHead(int i)
{
	if (root == NULL)
	{
		root = new ListElement(i);
	}
	else
	{
		ListElement *tmp = root;
		root = new ListElement(i, tmp);
	}

	++count;
}

void LinkedList::clear()
{
	if (count == 0) return;

	ListElement *tmp = root->pNext;

	while (tmp != NULL)
	{
		delete root;
		root = tmp;
		tmp = tmp->pNext;
	}
	delete root;
	root = NULL;
	count = 0;
}